package bioutil;

import java.util.ArrayList;
import java.util.concurrent.TimeUnit;
import sim.app.socialagents.CommSocialAgent;


/**
 * Class for creating/sending a gradient
 * This thread keeps sending a gradient
 * as long as the gradient duration of the source
 * agent is.
 * 
 * @author Adelein Rodriguez
 */
public class CommCreateGradientThread implements Runnable{

	public boolean debug =false;
	CommSocialAgent agent;
	Morphogen morphogen;
	long time;
	public boolean stop = false;


	public CommCreateGradientThread(CommSocialAgent agent, Morphogen morphogen, long time){
		
		this.agent=agent;
		this.morphogen=morphogen;
		this.time=time;
	
	}
	
	public void run(){
		
		ArrayList<CommSocialAgent> neighbors = agent.getNeighbors();
		
		Message messageToChildren;
		if(debug){
			System.out.println("Start to propagate gradient of duration: "+(int)agent.commParams.getGradientDuration());
		}
		for(int i = 0; i< (int)agent.commParams.getGradientDuration() && !agent.stopCreate && !stop; i++){
			neighbors = agent.getNeighbors();
			if(debug){
				System.out.println("Count down: "+i);
			}
			//Morphogen newMorphogen = new Morphogen(morphogen.name, morphogen.value);
			//newMorphogen.value--;
			 messageToChildren= new Message(morphogen,time);
			for(CommSocialAgent a : neighbors){
				if(debug){
					System.out.println("Agent "+agent.id+ "sent message to agent "+a.id);
				}
				a.messages.put(a, messageToChildren);
			}
			
			try{ TimeUnit.MILLISECONDS.sleep((long)agent.commParams.getPropagationDelay());}
			catch(InterruptedException e){}
	
		}
		
		
	}


}

