package bioutil;

import java.util.ArrayList;
import java.util.concurrent.TimeUnit;

import sim.app.socialagents.CommSocialAgent;

/**
 * Class for receiving a gradient
 * 
 * @author Adelein Rodriguez
 */

public class CommReceiveGradientThread implements Runnable{
	
	public boolean debug = false;
	CommSocialAgent agent;
	Message message;
	public boolean stop=false;

	public CommReceiveGradientThread(CommSocialAgent agent){
		
		this.agent=agent;

	}
	
	public void run(){
		
		while(true && !agent.searchingMode && !agent.stopReceive && !stop){
			while((message=(Message)agent.messages.get(agent))==null)
			{
				if(stop && agent.stopReceive){
					return;
				}
				try{TimeUnit.MILLISECONDS.sleep((int)agent.commParams.getCheckIfMessageDelay());}
				catch(InterruptedException e){}

			}
		
			agent.messages.remove(agent);
			if(agent.receiveGradient(message.morphogen)){
				//	Propagate Message
				//create new time, dont care about time for now
				
				long releaseTime=0;
				for(int i=0; i<(int)agent.commParams.getGradientDuration() && !agent.searchingMode && !agent.stopReceive && !stop; i++){
					Morphogen decreasedMorphogen = new Morphogen();
					decreasedMorphogen.name=message.morphogen.name;
					decreasedMorphogen.value=message.morphogen.value;
					decreasedMorphogen.value--;
					Message messageToChildren = new Message(decreasedMorphogen,releaseTime);
					if(debug){
						System.out.println(agent.id +" Sending  message" +messageToChildren+"to childen");
					}
					ArrayList<CommSocialAgent> neighbors = agent.getNeighbors();
					for(CommSocialAgent a : neighbors){
						
						a.messages.put(a,messageToChildren);
					}
					getNewMessage(message);//check if an update
					try{TimeUnit.MILLISECONDS.sleep((long)agent.commParams.getPropagationDelay());}
					catch(InterruptedException e){}
				}
				this.stop=true;
				agent.stopReceive=true;
				//remove gradient

			}//	end if
		}//end while
		
	}
	//	Check for a new message
	//	If this message is better than the previous one
	//	and it can be propagated exchange it with the old one
	//	else do nothing, agent will keep propagating old message
	boolean getNewMessage(Message oldMessage){
		
		Message newMessage;
		if((newMessage=(Message)agent.messages.get(agent))!=null){
			agent.messages.remove(agent);
			if(agent.receiveGradient(newMessage.morphogen)){
				oldMessage=newMessage;
				if(debug){
					System.out.println("##########################Changing color##############################");
				}
				return true;
			}
		}
		return false;
	}
	
	

}

