/* This class computes a simple vector in the opposite direction of a nearby agent
 * This will be used to avoid agent-agent collisions
 **/
package sim.app.socialagents;

import sim.util.*;

public class AvoidAgentGoal extends Goal{

	public AvoidAgentGoal(){

	}

	/* simply creates a vector pointing away from the otherPosition vector
	 **/
	public MutableDouble2D getVectorToGoal(CommAgent agent){

		MutableDouble2D vector = new MutableDouble2D(0.0, 0.0);
		Double2D otherPosition;
		double tmpx, tmpy, magn;

		for(int i = 0; i < agent.agentPositions.numObjs; i++){

			otherPosition = (Double2D)(agent.agentPositions.objs[i]);

			tmpx = otherPosition.x - agent.positionx;
			tmpy = otherPosition.y - agent.positiony;

			tmpx *= -1.0;
			tmpy *= -1.0;

			magn = Math.sqrt((tmpx*tmpx)+(tmpy*tmpy));

			if(magn != 0.0){
				tmpx/=magn;
				tmpy/=magn;

				vector.addIn(tmpx, tmpy);
			}
		}

		if(vector.lengthSq() != 0.0){
			vector.normalize();
		}
		return vector;
	}

}
