package sim.app.socialagents;

import java.util.concurrent.Executors;

import ec.util.MersenneTwisterFast;

public class CommunicationParameters {
	
	
	public MersenneTwisterFast rng;
	// How many times to propagate the gradient
	// once received
	int gradientDuration; 
	// Delay in MILLISECONDS between
	// gradient propagation pulses
	int  propagationDelay;
	// Delay in MILLISECONDs between
	// times we check our queue for mesages
	// from other agents' gradients
	int checkIfMessageDelay;
	// The number of  gradient hoops
	// if I am a source (gradient emitter)
	int gradientStrength;
	// Speed the agent moves at once it received
	// a gradient and started to propagate it
	double speedWhilePropagating;
	double parameters[];
	

	public CommunicationParameters(double[] parameters){
		this.parameters=parameters;
	}
	
	public double getGradientDuration(){
		return parameters[0];
	}
	public double getPropagationDelay(){
		return parameters[1];
	}
	public double getCheckIfMessageDelay(){
		return parameters[2];
	}
	public double getGradientStrength(){
		return parameters[3];
	}
	public double getSpeedWhilePropagating(){
		return parameters[4];
	}
	
	

}
