package sim.app.socialagents;

import sim.util.Double2D;
import sim.util.MutableDouble2D;

public class GoToAgentGoal {
	
	public MutableDouble2D getVectorToGoal(Agent agent){

		MutableDouble2D vector = new MutableDouble2D(0.0, 0.0);
		Double2D otherPosition;
		double tmpx, tmpy, magn;

		for(int i = 0; i < agent.agentPositions.numObjs; i++){

			otherPosition = (Double2D)(agent.agentPositions.objs[i]);

			tmpx = otherPosition.x - agent.positionx;
			tmpy = otherPosition.y - agent.positiony;
			magn = Math.sqrt((tmpx*tmpx)+(tmpy*tmpy));

			if(magn != 0.0){
				tmpx/=magn;
				tmpy/=magn;

				vector.addIn(tmpx, tmpy);
			}
		}

		if(vector.lengthSq() != 0.0){
			vector.normalize();
		}
		return vector;
	}

}
