/* This class computes a simple vector in the direction of a nearby AOI
 * This will be used to avoid agent-obstacle collisions
 **/
package sim.app.socialagents;

import sim.util.*;

public class GotoAOIGoal extends Goal{

	public GotoAOIGoal(){

	}

	/* simply creates a vector pointing away from the otherPosition vector
	 **/
	public MutableDouble2D getVectorToGoal(CommAgent agent){

		MutableDouble2D vector = new MutableDouble2D(0.0, 0.0);
		Double2D aoiPosition;
		double tmpx, tmpy, magn;

		for(int i = 0; i < agent.aoiPositions.numObjs; i++){

			aoiPosition = (Double2D)agent.aoiPositions.objs[i];
			tmpx = aoiPosition.x - agent.positionx;
			tmpy = aoiPosition.y - agent.positiony;

			magn = Math.sqrt((tmpx*tmpx)+(tmpy*tmpy));

			if(magn != 0.0){
				tmpx/=magn;
				tmpy/=magn;

				vector.addIn(tmpx, tmpy);
			}

		}

		if(vector.lengthSq() != 0.0){
			vector.normalize();
		}

		return vector;

	}

}
