/* This class computes a simple vector in the direction of a nearby AOI
 * This will be used to avoid agent-obstacle collisions
 **/
package sim.app.socialagents;

import sim.util.*;

public class GotoMessagePointGoal extends Goal{

	public GotoMessagePointGoal(){

	}

	/* simply creates a vector pointing away from the otherPosition vector
	 **/
	public MutableDouble2D getVectorToGoal(CommAgent agent){

		MutableDouble2D vector = new MutableDouble2D(0.0, 0.0);
		double tmpx, tmpy;

		if(agent instanceof NonSocialAgent || ((SocialAgent)agent).getGoalPoint() == null){
			return vector;
		}else{
			tmpx = ((SocialAgent)agent).getGoalPoint().x - agent.positionx;
			tmpy = ((SocialAgent)agent).getGoalPoint().y - agent.positiony;
			vector = new MutableDouble2D(tmpx, tmpy);
			vector.normalize();
			return vector;
		}

	}

}
