package sim.app.socialagents; 

import ec.*; 
import ec.vector.*; 
import ec.util.*;

public class SocialSpecies extends VectorSpecies { 
	public final static String P_MIN_NON_GOAL = "min-non-goal"; 
	public final static String P_MAX_NON_GOAL = "max-non-goal"; 
	public final static String P_NUM_GOAL_PARAMS = "num-goal-params"; 
	public final static String P_NUM_NON_GOAL_PARAMS = "num-non-goal-params"; 
	public final static String P_NUM_CONDITIONS = "num-conditions"; 
	
	public double minNonGoal, maxNonGoal; 
	public int numGoalParams, numNonGoalParams, numConditions; 
	
	public void setup(final EvolutionState state, final Parameter base)
	{
		minNonGoal = state.parameters.getDouble(base.push(P_MIN_NON_GOAL), null,0); 
		maxNonGoal = state.parameters.getDouble(base.push(P_MAX_NON_GOAL), null,0); 
		numGoalParams = state.parameters.getInt(base.push(P_NUM_GOAL_PARAMS), null, 0); 
		numNonGoalParams = state.parameters.getInt(base.push(P_NUM_NON_GOAL_PARAMS), null, 0); 
		numConditions= state.parameters.getInt(base.push(P_NUM_CONDITIONS), null, 0); 
		super.setup(state,base);
	}
}
