package sim.app.socialagents;

public class UtilityFunctions{

	//////////////////////
	// STRING FUNCTIONS //
	//////////////////////

	/* pads the String on the right with spaces until it's length is equal to len
	 **/
	public static String rightPad(String str, int len){

		String ret = new String(str);

		while(ret.length() < len) ret += " ";

		return ret;

	}

	/* pads the String on the left with spaces until it's length is equal to len
	 **/
	public static String leftPad(String str, int len){

		String ret = new String(str);

		while(ret.length() < len) ret = " " + ret;

		return ret;

	}
	
	/* pads the number on the right with spaces
	 **/
	public static String rightPad(int n, int length){

		return UtilityFunctions.rightPad(""+n, length);

	}

	/* pads the number on the left with spaces
	 **/
	public static String leftPad(int n, int length){

		return UtilityFunctions.leftPad(""+n, length);

	}

	/////////////////////
	// ARRAY FUNCTIONS //
	/////////////////////

	/* returns the sum of the values in the array
	 **/
	public static int getArraySum(int[] array){

		int sum = 0;

		for(int i = 0; i < array.length; i++){
			sum += array[i];
		}

		return sum;

	}

	/* returns the sum of the values in the array
	 **/
	public static double getArraySum(double[] array){

		double sum = 0.0;

		for(int i = 0; i < array.length; i++){
			sum += array[i];
		}

		return sum;

	}

	/* returns the max value in the array
	 **/
	public static double getArrayMaxValue(double[] array){

		double max = Double.NEGATIVE_INFINITY;

		for(int i = 0; i < array.length; i++){
			if(array[i] > max) max = array[i];
		}

		return max;

	}

	/* returns the average of the values in the array
	 **/
	public static double getArrayAvg(int[] array){

		return (double)UtilityFunctions.getArraySum(array) / array.length;

	}

	/* returns the average of the values in the array
	 **/
	public static double getArrayAvg(double[] array){

		return UtilityFunctions.getArraySum(array) / array.length;

	}

	/* returns the standard deviation of the values in the array
	 **/
	public static double getArrayStdDev(int[] array){

		double avg = UtilityFunctions.getArrayAvg(array);
		double sum = 0.0;

		for(int i = 0; i < array.length; i++){
			sum += Math.pow(array[i] - avg, 2.0);
		}

		return Math.sqrt(sum / (array.length - 1));

	}

	/* returns the standard deviation of the values in the array
	 **/
	public static double getArrayStdDev(double[] array){

		double avg = UtilityFunctions.getArrayAvg(array);
		double sum = 0.0;

		for(int i = 0; i < array.length; i++){
			sum += Math.pow(array[i] - avg, 2.0);
		}

		return Math.sqrt(sum / (array.length - 1));

	}

}
