package sim.app.socialagents;

import java.util.*;
import java.io.*;

public class WriteFullRunGoalParamsTruePerGenGNU{

	public static void main(String[] args) throws Exception{

		if(args.length != 1){
			System.err.println("USAGE: java WriteFullRunGoalParamsTruePerGenGNU [run_num]");
			return;
		}

		PrintWriter pr;
		int runNum;
		int numGenerations, popSize;
		ConfigParams params;

		runNum = Integer.parseInt(args[0]);

		params = new ConfigParams("output/run" + runNum + "/params.txt");

		numGenerations = params.getParamInt("NUM_GENERATIONS");
		popSize = params.getParamInt("POP_SIZE");

		pr = new PrintWriter(new BufferedWriter(new FileWriter("output/fullRunGoalParamsTruePerGen" + runNum + ".gnu")));

		for(int curGen = 0; curGen < numGenerations; curGen++){

			pr.println("plot [" + (curGen * popSize) + ":" + ((curGen + 1) * popSize - 1) + "][0:1000]\\");
			pr.println("    \"run" + runNum + "/fullRun.txt\" using 4, \"run" + runNum + "/fullRun.txt\" using 20, \"run" + runNum + "/fullRun.txt\" using 21, \"run" + runNum + "/fullRun.txt\" using 22, \"run" + runNum + "/fullRun.txt\" using 23, \"run" + runNum + "/fullRun.txt\" using 24");
			pr.println("pause -1 \"hit enter\"");
			pr.println();

		}

		pr.close();

	}

}
