package sim.app.socialagents;

import java.util.*;
import java.io.*;

public class WriteFullRunParamsGNU{

	public static void main(String[] args) throws Exception{

		if(args.length != 2){
			System.err.println("USAGE: java WriteFullRunParamsGNU [run_num_start] [run_num_end]");
			return;
		}

		PrintWriter pr;
		int runNumStart, runNumEnd;

		runNumStart = Integer.parseInt(args[0]);
		runNumEnd   = Integer.parseInt(args[1]);

		pr = new PrintWriter(new BufferedWriter(new FileWriter("output/fullRunParams" + runNumStart + "-" + runNumEnd + ".gnu")));

		for(int curRun = runNumStart; curRun <= runNumEnd; curRun++){

			pr.println("plot [][0:1]\\");
			pr.println("    \"run" + curRun + "/fullRun.txt\" using 8 title \"Run:" + curRun + " fitness\",\\");
			pr.println("    \"run" + curRun + "/fullRun.txt\" using 10 title \"randomness\",\\");
			pr.println("    \"run" + curRun + "/fullRun.txt\" using 11 title \"comfort\",\\");
			pr.println("    \"run" + curRun + "/fullRun.txt\" using 12 title \"avoid agent\",\\");
			pr.println("    \"run" + curRun + "/fullRun.txt\" using 13 title \"avoid obstacle\",\\");
			pr.println("    \"run" + curRun + "/fullRun.txt\" using 14 title \"momentum\",\\");
			pr.println("    \"run" + curRun + "/fullRun.txt\" using 15 title \"goto AOI\",\\");
			pr.println("    \"run" + curRun + "/fullRun.txt\" using 16 title \"follow obstacle\"");

			pr.println("pause -1 \"hit enter\"");
			pr.println();

		}

		pr.close();

	}

}
