package sim.app.socialagents;

import java.util.*;
import java.io.*;

public class WriteFullRunParamsPerGenGNU{

	public static void main(String[] args) throws Exception{

		if(args.length != 1){
			System.err.println("USAGE: java WriteFullRunParamsPerGenGNU [run_num]");
			return;
		}

		PrintWriter pr;
		int runNum;
		int numGenerations, popSize;
		ConfigParams params;

		runNum = Integer.parseInt(args[0]);

		params = new ConfigParams("output/run" + runNum + "/params.txt");

		numGenerations = params.getParamInt("NUM_GENERATIONS");
		popSize = params.getParamInt("POP_SIZE");

		pr = new PrintWriter(new BufferedWriter(new FileWriter("output/fullRunParamsPerGen" + runNum + ".gnu")));

		for(int curGen = 0; curGen < numGenerations; curGen++){

			pr.println("plot [" + (curGen * popSize) + ":" + ((curGen + 1) * popSize - 1) + "][0:1]\\");

			pr.println("    \"run" + runNum + "/fullRun.txt\" using 8 title \"Run:" + runNum + " Gen:" + curGen + " fitness\",\\");
			pr.println("    \"run" + runNum + "/fullRun.txt\" using 10 title \"randomness\",\\");
			pr.println("    \"run" + runNum + "/fullRun.txt\" using 11 title \"comfort\",\\");
			pr.println("    \"run" + runNum + "/fullRun.txt\" using 12 title \"avoid agent\",\\");
			pr.println("    \"run" + runNum + "/fullRun.txt\" using 13 title \"avoid obstacle\",\\");
			pr.println("    \"run" + runNum + "/fullRun.txt\" using 14 title \"momentum\",\\");
			pr.println("    \"run" + runNum + "/fullRun.txt\" using 15 title \"goto AOI\",\\");
			pr.println("    \"run" + runNum + "/fullRun.txt\" using 16 title \"follow obstacle\"");

			pr.println("pause -1 \"hit enter\"");

			pr.println();

		}

		pr.close();

	}

}
